
var MACHINE_QUANTITY_PER_HOUR = 0;
var CUSTOMER_ORDER_PLAN_DATA_ID = undefined;
var PRODUCT_PRIMARY_ID = undefined;
var CUSTOMER_ORDER_PLAN_ID = undefined;
var FG_PRODUCT_ID = undefined;
var productChooser = null;
$(document).ready(function () {

    var orderPlanTable = $('#OrderPlanTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "id" },
            { "data": "manufacturing_Order_number" },
            { "data": "order_id" },
            { "data": "trans_date" },
            { "data": "delivery_date" },
            { "data": "description" },

        ],
        columnDefs: [
            { width: 100, targets: 0, "visible": false },
            { width: 150, targets: 1 },
            { width: 150, targets: 2 },
            { width: 100, targets: 3 },
            { width: 100, targets: 4 },

        ],
    });



    var ProductOrderTable = $('#ProductOrderTable').DataTable({
        //responsive: true,
        "order": [],
        "columns": [
            { "data": "id" },
            { "data": "product_primary_id" },
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "quantity" },
            { "data": "machine" },
            { "data": "bom" },
            { "data": "hr" },
            { "data": "bags" },

        ],
        columnDefs: [
            { width: 100, targets: 0, "visible": false },
            { width: 100, targets: 1, "visible": false },
            { width: 100, targets: 2 },
            { width: 100, targets: 4 },
            { width: 50, targets: 5 },
            { width: 50, targets: 6 },
            { width: 50, targets: 8, "visible": false },
        ],
    });


    ProductOrderTable.column(5).visible(allocate_resource_machine == 1);
    ProductOrderTable.column(6).visible(allocate_resource_bom == 1);
    ProductOrderTable.column(7).visible(allocate_resource_hr == 1);

    allOrderPlan();






    $('#OrderPlanTable tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            orderPlanTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = orderPlanTable.row(this).data();
            var customer_order_plan_id = rowData.customer_order_plan_id;
            CUSTOMER_ORDER_PLAN_ID = rowData.customer_order_plan_id;
            getOrderPlanData(customer_order_plan_id);



        }
    });



    $('#ProductOrderTable tbody').on('click', 'tr', function () {

        /*if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            ProductOrderTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = ProductOrderTable.row(this).data();
            CUSTOMER_ORDER_PLAN_DATA_ID = rowData.id;
            PRODUCT_PRIMARY_ID = rowData.product_primary_id;

        }*/

        var rowData = ProductOrderTable.row(this).data();
        CUSTOMER_ORDER_PLAN_DATA_ID = rowData.id;
        PRODUCT_PRIMARY_ID = rowData.product_primary_id;
        FG_PRODUCT_ID = rowData.product_primary_id;


    });

    /*$('#ProductOrderTable').on('click', '.BOM', function () {
        CUSTOMER_ORDER_PLAN_DATA_ID = $(this).closest('tr').find('td:eq(0)').text(); // amend the index as needed
        PRODUCT_PRIMARY_ID = $(this).closest('tr').find('td:eq(1)').text();

    });*/




    $("#cmbFactory").change(function () {
        loadMachinesToFactory(this.value);
        clearAllocatedTable();
    });

    $("#cmbMachine").change(function () {
        MACHINE_QUANTITY_PER_HOUR = quantityPerHour(this.value);
        clearAllocatedTable();
        getAllocatedData(CUSTOMER_ORDER_PLAN_DATA_ID, PRODUCT_PRIMARY_ID, $(this).val());
    });




    $('#btnSaveMachintoProduct').on('click', function () {

        saveAllocateToMachine();
    });





    productChooser = $('#productChooser').dataChooser({
        "columns": [
            { "data": "id" },
            { "data": "value0" },
        ],
        columnDefs: [
            { width: 200, targets: 0 },
            { width: 300, targets: 1 },
        ],
    });

    var product_data = allRawMaterialProducts();
    //console.log(product_data);
    productChooser.setDataSource(product_data);


    productChooser.on('select', function (event, data) {
        var input = productChooser.getInput();
        input.focus();

        var product_id = data[0];
        var product_name = data[1];
        input.attr("data-id", product_id);
        input.val(product_name);

    });


    $('#btnSaveBOMtoProduct').on('click', function () {

        saveAllocateToBOM();
    });


    $('#btnSaveHRtoProduct').on('click', function () {

        saveAllocateToHR();
    });


    $('#cmbBomName').on('change', function () {
        getSelectedProductBOMData(CUSTOMER_ORDER_PLAN_DATA_ID, PRODUCT_PRIMARY_ID, $(this).val());
    });


});



function clearAllocatedTable() {
    $('#tblAllocateProduct').empty();
    addMachineRow(0);
}



function loadAllOrder() {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/addOrder/all',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    var order = value.purchase_order + " (" + value.factory_po_num + ")";
                    html += '<option value="' + value.order_id + '">' + order + '</option>';
                    //console.log(html);
                })
                $('#selcPurchaseOrder').html(html);

            } else {

                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });
}












/**
* getOrderPlan
* This function is used to get customer order to the list view.
* This is the paramter to ajax data
*/

function allOrderPlan() {

    $.ajax({
        type: "GET",
        url: "/pp/allocateMachine/allOrderPlan",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            manufacturing_Order_number = undefined;
            if (response.data.success) {
                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_id'];
                    order_id = response.data.result[i]['order_id'];
                    var trans_date = response.data.result[i]['trans_date'];
                    var delivery_date = response.data.result[i]['trans_date'];
                    var from_date = response.data.result[i]['from_date'];
                    var to_date = response.data.result[i]['to_date'];
                    var description = response.data.result[i]['description'];
                    var manufacturing_order_number = response.data.result[i]['manufacturing_order_number'];
                    var purchase_order = response.data.result[i]['purchase_order'];
                    //var quantity_pieces = response.data.result[i]['quantity_pieces'];


                    var string_id = "'" + id + "'";
                    data.push({
                        "id": order_id,
                        "customer_order_plan_id": id,
                        "manufacturing_Order_number": manufacturing_order_number,
                        "order_id": purchase_order,
                        "trans_date": trans_date,
                        "delivery_date": delivery_date,
                        /*"quantity": quantity_pieces,
                        "from_date": from_date,
                        "to_date": to_date,*/
                        "description": description,

                    });
                }


                var table = $('#OrderPlanTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}


/**
* getOrderPlanData
* This function is used to get customer order data to the list view.
* This is the paramter to ajax data
*/
function getOrderPlanData(order_id) {

    $.ajax({
        type: "GET",
        url: "/pp/allocateMachine/allOrderPlanData/" + order_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                var disable = { 0: "", 1: "checked" }
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_data_id'];
                    var product_primary_id = response.data.result[i]['product_primary_id'];
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var string_id = "'" + id + "'";
                    var string_product_id = "'" + product_primary_id + "'";
                    data.push({
                        "id": id,
                        "product_primary_id": product_primary_id,
                        "product_id": product_id,
                        "product_name": product_name,
                        "quantity": quantity,
                        "machine": '<button type="button" class="btn btn-primary" onclick="showMachineModal(' + string_id + ',' + string_product_id + ')">Machine</button>',
                        "bom": '<button type="button" class="btn btn-primary BOM" onclick="showBOMModal(' + string_id + ',' + string_product_id + ')">BOM</button>',
                        "hr": '<button type="button" class="btn btn-primary" onclick="showHRModal(' + string_id + ',' + string_product_id + ')">HR</button>',
                        "bags": '<button type="button" class="btn btn-primary" onclick="showBagsModal(' + string_id + ')">Bags</button>',

                    });
                }


                var table = $('#ProductOrderTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}



function showAllocateModal(customer_order_plan_data_id, product_primary_id) {

    getSelectedProductData(customer_order_plan_data_id, product_primary_id);
    factories();
    $('#allocateMachineModal').modal('toggle');
}




function getSelectedProductData(customer_order_plan_data_id, product_primary_id) {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getSelectedProductData/' + customer_order_plan_data_id + "/" + product_primary_id+"/0",
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {
                $('#lblProductCode').text(": " + response.data.result.product_code);
                $('#lblProductName').text(": " + response.data.result.product_name);
                $('#lblFactoryPO').text(": " + response.data.result.factory_po);
                $('#lblCustomerPO').text(": " + response.data.result.customer_po);
                $('#lblProductionQty').text(": " + response.data.result.quantity);
                $('#lblProductionQty').attr("data-id", response.data.result.quantity);
                $('#lblAllocateQty').text(": " + response.data.result.allocated_quantity);
                $('#lblAllocateQty').attr("data-id", response.data.result.allocated_quantity);
                $('#cmbFactory').trigger('change');
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });
}





function factories() {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/factories',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.site_id + '">' + value.site + '</option>';
                })
                $('#cmbFactory').html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}




function loadMachinesToFactory(id) {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/loadMachinesToFactory/' + id,
        success: function (response) {
            console.log(response.result)
            if (response.success) {
                $('#cmbMachine').empty();
                $('#cmbMachine').append('<option selected disabled>--Select Here--</option>');
                for (i = 0; i < response.result.length; i++) {
                    var id = response.result[i]['machinery_id'];
                    var no = response.result[i]['machinery_no'];
                    var name = response.result[i]['machinery_name'];
                    var nn = no + "-" + name;
                    $('#cmbMachine').append('<option value="' + id + '">' + nn + '</option>');
                }


            }
        }, error: function (data) {
            console.log('something went wrong');
        }
    });
}


function addMachineRow(id) {
    $('#' + id).text("Remove");
    $('#' + id).attr('class', 'btn btn-danger remove');
    $('#' + id).attr('onclick', '');

    var btn_id = guidGenerator();
    var txtDate_id = "txtDate" + guidGenerator();
    var txtFrom_id = "txtFrom" + guidGenerator();
    var txtTo_id = "txtTo" + guidGenerator();
    var txtQty_id = "txtQty" + guidGenerator();
    var txtAllocatedQty_id = "allocatedQty" + guidGenerator();
    var txtOutput_id = "txtQty" + guidGenerator();
    var cmb_id = "cmb" + guidGenerator();

    var string_txtFrom_id = "'" + txtFrom_id + "'";
    var string_txtTo_id = "'" + txtTo_id + "'";
    var string_txtQty_id = "'" + txtQty_id + "'";
    var string_txtOutput_id = "'" + txtOutput_id + "'";
    var string_id = "'" + btn_id + "'";

    var row = '<tr id="' + id + '"><td><input id="' + txtDate_id + '" data-id="' + txtAllocatedQty_id + '" data-id2="' + txtFrom_id + '" data-id3="' + txtTo_id + '" type="text" class="form-control-sm" style="width:130px; border:1px solid gray;" name="dteDate" id="dteDate" autocomplete="off"></td>';
    row += '<td><input id="' + txtFrom_id + '" type="text" class="form-control-sm" style="width:80px; border:1px solid gray;" autocomplete="off" oninput="calculateOutput(' + string_txtFrom_id + ',' + string_txtTo_id + ',' + string_txtQty_id + ',' + string_txtOutput_id + ')"></td>';
    row += '<td><input id="' + txtTo_id + '" type="text" class="form-control-sm" style="width:80px; border:1px solid gray;" autocomplete="off" oninput="calculateOutput(' + string_txtFrom_id + ',' + string_txtTo_id + ',' + string_txtQty_id + ',' + string_txtOutput_id + ')"></td>';
    row += '<td><input id="' + txtQty_id + '" type="text" class="form-control-sm newQty" style="width:100px;text-align:right; border:1px solid gray;"  autocomplete="off" oninput="isCapacityExeeded(' + string_txtQty_id + ',' + string_txtOutput_id + ');validate_to_allocatedQty_to_productionQty()"></td>';
    row += '<td><input id="' + txtOutput_id + '" type="text" class="form-control-sm" style="width:100px;text-align:right; border:1px solid gray;" id="date" autocomplete="off" oninput="isCapacityExeeded(' + string_txtQty_id + ',' + string_txtOutput_id + ');"></td>';
    row += '<td><input id = "' + txtAllocatedQty_id + '" type="text" class="form-control-sm" style="width:100px; border:1px solid gray;" id="date" autocomplete="off"></td>';
    row += '<td><select id="' + cmb_id + '" class="form-control" style="width:200px;"></select></td>';
    row += '<td><button type="button" id="' + btn_id + '" class="btn btn-primary" onclick="addMachineRow(' + string_id + ')">Add</button></td></tr>';
    $('#tblAllocateProduct').append(row);

    $(".remove").click(function () {
        $(this).closest("tr").remove();
    });

    $('input[name="dteDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }
    });
    $('#' + txtDate_id).val('');
    $('input[name="dteDate"]').on('apply.daterangepicker', function (ev, picker) {
        var from = $('#' + $(this).attr('data-id2')).val();
        var to = $('#' + $(this).attr('data-id3')).val();
        var allocatedQty = getAllocatedQuantityFromDate(CUSTOMER_ORDER_PLAN_DATA_ID, PRODUCT_PRIMARY_ID, $('#cmbMachine').val(), $(this).val(), from, to);
        $('#' + $(this).attr('data-id')).val(allocatedQty);


    });


    $('#' + cmb_id).on('change', function () {
        get_from_to($(this).val(), txtFrom_id, txtTo_id);
    });

    allShift(cmb_id);
    return {
        "btn_id": btn_id,
        "date": $('#' + txtDate_id),
        "from": $('#' + txtFrom_id),
        "to": $('#' + txtTo_id),
        "quantity": $('#' + txtQty_id),
        "output": $('#' + txtOutput_id),
        "allocate": $('#' + txtAllocatedQty_id),
        "shift": $('#' + cmb_id),

    };

}



function guidGenerator() {
    var S4 = function () {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return (S4() + S4());
}




function allShift(id) {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/allShift',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.shift_id + '">' + value.shift_name + '</option>';
                })
                $('#' + id).html(html);
                $('#' + id).change();
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function quantityPerHour(machine_id) {
    var quantity = 0;
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/quantityPerHour/' + machine_id,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            quantity = response.data.result;
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return quantity;
}





function calculateOutput(from_id, to_id, qty_id, output_id) {

    var from = $('#' + from_id).val();
    var to = $('#' + to_id).val();
    var qty = $('#' + qty_id).val();
    var output = (to - from) * MACHINE_QUANTITY_PER_HOUR;
    if (output < 0) {
        output = 0;
    }
    $('#' + output_id).val(output);

}


function isCapacityExeeded(qty_id, output_id) {

    var qty = parseFloat($('#' + qty_id).val());
    var output = parseFloat($('#' + output_id).val());

    if (qty > output) {
        //showWarningMessage('Maximum capacity exeeded.');
        showWarningMessage("Maximum capacity exeeded.<br>Quantity :" + qty + "<br>Max Output Qty :" + output);

    }
}




function dataSource() {

    var collection = {};
    var table = document.getElementById('tblAllocateProduct'),
        rows = table.getElementsByTagName('tr'),
        i, j, cells, customerId;

    for (i = 0, j = rows.length; i < j; ++i) {
        cells = rows[i].getElementsByTagName('td');
        if (!cells.length) {
            continue;
        }
        var data = {
            "date": cells[0].childNodes[0].value,
            "from": cells[1].childNodes[0].value,
            "to": cells[2].childNodes[0].value,
            "quantity": cells[3].childNodes[0].value,
            "output": cells[4].childNodes[0].value,
            "allocated": cells[5].childNodes[0].value,
            "shift": cells[6].childNodes[0].value,
        };
        collection[i] = JSON.stringify(data);



    }

    return collection;

};


function saveAllocateToMachine() {

    console.log(dataSource());
    $.ajax({
        type: "POST",
        url: '/pp/allocateMachine/saveAllocateToMachine',
        data: {
            "customer_order_plan_data_id": CUSTOMER_ORDER_PLAN_DATA_ID,
            'machinery_id': $('#cmbMachine').val(),
            "product_primary_id": PRODUCT_PRIMARY_ID,
            'data': dataSource(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Data has been saved successful');
                clearAllocatedTable();
                $('#cmbMachine').prop('selectedIndex', 0);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
            $('#allocateMachineModal').modal('hide');
        }

    });
}


function getAllocatedData(order_id, product_id, machine_id) {

    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getAllocatedData/' + order_id + "/" + product_id + "/" + machine_id,
        async: false,
        beforeSend: function () {
            //progress(true);
        },
        success: function (response) {
            console.log(response.data.result);
            var result = response.data.result;
            if (result.length > 0) {
                var childarray = { "btn_id": 0 };
                $('#tblAllocateProduct').empty();
                for (var i = 0; i < result.length; i++) {

                    childarray = addMachineRow(childarray.btn_id);
                    childarray.date.val(result[i].date);
                    childarray.from.val(result[i].from);
                    childarray.to.val(result[i].to).trigger("input");
                    childarray.quantity.val(result[i].quantity);
                    childarray.quantity.attr("class", "form-control-sm oldQty");
                    childarray.shift.val(result[i].shift_id);
                    childarray.date.trigger('apply.daterangepicker');

                }
                addMachineRow(childarray.btn_id);

            }

        },
        error: function (data) {

        },
        complete: function () {
            //progress(false);
        }
    });

}



function getAllocatedQuantityFromDate(order_id, product_id, machine_id, date, from, to) {

    var quantity = 0;
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getAllocatedQuantityFromDate/' + order_id + "/" + product_id + "/" + machine_id + "/" + date + "/" + from + "/" + to,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.result != null) {
                quantity = response.data.result;
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return quantity;
}





function showMachineModal(customer_order_plan_data_id, product_primary_id) {
    showAllocateModal(customer_order_plan_data_id, product_primary_id);
}


function validate_to_allocatedQty_to_productionQty() {

    var allocated_qty = parseFloat($('#lblAllocateQty').attr('data-id'));
    var production_qty = parseFloat($('#lblProductionQty').attr('data-id'));
    var qty_array = $('.newQty').map((_, el) => el.value).get();
    var new_allocated_qty = 0;
    for (var i = 0; i < qty_array.length; i++) {
        new_allocated_qty += parseFloat(qty_array[i]);
    }
    if (parseFloat(allocated_qty + new_allocated_qty) > production_qty) {
        showWarningMessage("Maximum capacity exeeded.<br>Production Qty :" + production_qty + "<br>Allocated Qty :" + parseFloat(allocated_qty + new_allocated_qty));
    }


}



function get_from_to(shift_id, from_id, to_id) {


    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/get_from_to/' + shift_id,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {
                $('#' + from_id).val(response.data.result.from);
                $('#' + to_id).val(response.data.result.to);

            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}





/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}







